



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基本套接字总结（@function）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基本套接字总结（@function）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 17:27:12 </span>
						</div>
										<div class="post-content">
											
		<p>最近学习了下UNIX下的网络编程。为了以后查询方便，总结在这里。</p>
<p>首先套接字的地址定义：</p>
<p>　　　IPv4地址和IPv6地址定义见&lt;netinet/in.h&gt;头文件定义。为了能够顺利转换不同的套接字内容，可以查看&lt;sys/socket.h&gt;中定义的通用套接字struct sockaddr;在使用过成中我们可以将struct sockaddr_in 和 sockaddr_in6直接强制转换成struct sockaddr.</p>
<p>连接过程中我们需要人工指定对应网络地址。而不同的主机实现中存在不同的数据格式（big-endian OR little-endian),我们需要通过如下转换函数来保证数据转换过程中的正确性。</p>
<p>函数列表如下：　　　</p>
<div>
<pre class="prettyprint linenums">#include &lt;netinet/in.h&gt;<br />
//from host byte order to network byte order<br />
uint16_t htons(uint16_t  host16bitvalue)<br />//servaddr.sin_addr.s_addr = htonl(INADDR_ANY); &nbsp;<br />
uint32_t htonl(uint32_t  host32bitvalue)

//from network byte order to host byte order<br />
uint16_t ntohs(uint16_t  host16bitvalue)<br />
uint16_t ntohl(uint16_t  host16bitvalue)</pre>
</div>
<p>地址转换函数使用：</p>
<div>
<pre class="prettyprint linenums">#include &lt;arpa/inet.h&gt;

int inet_pton(int family, const char* strptr, void *addrptr);　　//成功返回1，格式错误返回0，出错返回-1<br />//示例：：Inet_pton(AF_INET, argv[1], &amp;serveraddr.sin_addr);

const char* inet_ntop(int family, const void*addrptr, char *strptr, size_t len); //len参数指出缓存区的大小，避免出现溢出</pre>
</div>
<p>基本TCP套接字编程示例程序如下（这里我们read,write等系统IO操作来实现网络回射服务）：</p>
<p>其中涉及到的网络编程函数包括：socket(),bind(),bzero(),inet_pton(), listen(),connect(),accept()</p>
<p>服务过程中socket()指定所要进行操作的网络服务是什么， socket(指定协议族， 操作类型， 采用协议)</p>
<p>协议族包括：AF_INET:Pv4；　　AF_INET6:IPv6;　　AF_LOCAL:UNIX域协议；　　AF_ROUTE:路由套接字；　　AF_KEY:密钥套接字</p>
<p>操作类型：SOCK_STREAM:字节流;　　SOCK_DGRAM:数据报;　　SOCK_SEQPACKET:有序分组;　　SOCK_RAW:原始套接字</p>
<p>采用协议：IPPROTO_TCP...._UDP...._SCTP</p>
<p>需要注意的问题：</p>
<p>　　Fork子进程后，connfd和listenfd的引用次数变成2，所以需要在子进程和父进程中同时关闭才能保证完全关闭。</p>
<p>　　多个子进程并发后，会在服务器上产生大量的僵死进程，从而使得大量的服务器资源浪费。为此我们需要捕获僵死进程的信号SIGCHLD，并做相应的处理。因为UNIX中信号不排队的设计，采用wait处理完第一个僵死进程的信号后其余的进程信号丢失。从而清理不彻底。为此，这里采用waitpid函数进行处理。</p>
<p>首先，服务器程序：</p>
<div>
<pre class="prettyprint linenums">#include "unp.h"<br />
#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;

void str_echo(int sockfd);<br />
Sigfunc* signal1(int signo, Sigfunc* func);<br />
void sig_child(int signo);<br />
int main(int argc, char** argv){<br />
    int listenfd, connfd;<br />
    char buff[MAXLINE];<br />
    pid_t childpid;<br />
    socklen_t clilen;

    struct sockaddr_in cliaddr, servaddr;

    //&lt;sys/socket.h&gt;<br />
    //int socket(int family, int type, int protocal);<br />
    listenfd = Socket(AF_INET, SOCK_STREAM, );<br />
    bzero(&amp;servaddr, sizeof(struct sockaddr_in));<br />
    servaddr.sin_family = AF_INET;<br />
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);<br />
    servaddr.sin_port = htons(SERV_PORT);

    Bind(listenfd, (SA*) &amp;servaddr, sizeof(servaddr));

    Listen(listenfd, LISTENQ);

    //working with the<br />
    signal1(SIGCHLD, sig_child);

    while(){<br />
        clilen = sizeof(cliaddr);<br />
        connfd = Accept(listenfd, (SA*)&amp;cliaddr, &amp;clilen);<br />
        if ((childpid = Fork()) == ){<br />
            Close(listenfd);<br />
            str_echo(connfd);<br />
            exit();<br />
        }<br />
        Close(connfd);<br />
    }

    return ;<br />
}

void str_echo(int sockfd){<br />
    ssize_t n;<br />
    char buf[MAXLINE];<br />
again:<br />
    while((n = read(sockfd, buf, MAXLINE) ) &gt; )<br />
        Write(sockfd, buf, n);<br />
    if (n &lt;  &amp;&amp; errno == EINTR)<br />
        goto again;<br />
    else if (n &lt; )<br />
        err_sys("str_echo: read error");

}

Sigfunc* signal1(int signo, Sigfunc* func){<br />
    struct sigaction act, oact;<br />
    act.sa_handler = func;<br />
    sigemptyset(&amp;act.sa_mask);<br />
    act.sa_flags = ;<br />
    if ( signo == SIGALRM){<br />
#ifdef SA_INTERRUPT<br />
        //设定中断,使该信号处理过程中能够中断:<br />
        act.sa_flags |= SA_INTERRUPT;<br />
#endif<br />
    }else{<br />
#ifdef    SA_RESTART<br />
        //信号处理，设置SA_RESTART标志，使得内核对失败的<br />
        //系统调用自动重启。<br />
        act.sa_flags |= SA_RESTART;<br />
#endif<br />
    }

    if (sigaction(signo, &amp;act, &amp;oact) &lt; ){<br />
        return SIG_ERR;<br />
    }<br />
    return (oact.sa_handler);<br />
}

void sig_child(int signo){<br />
    pid_t pid;<br />
    int stat;<br />
    /***********************************************<br />
#inlcude &lt;sys/wait.h&gt;<br />
        这里使用wait函数只能处理第一个返回的僵死进程，因为其UNIX系统信号实现<br />
        中信号是不进行排队的。所以我们采用waitpid<br />
        并且设定最后的选项为WNOHANG.表示内核在没有进程时不仅行阻塞。<br />
        ***********************************************/<br />
    //  --- pid = wait(&amp;stat);<br />
    while(( pid = waitpid(-, &amp;stat, WNOHANG)) &gt; )<br />
        printf("child %d terminated.\n", pid);<br />
    return;<br />
}</pre>
</div>
<p>客户端程序：</p>
<div>
<pre class="prettyprint linenums">#include "unp.h"<br />
#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;

int str_cli1(FILE *fp, int sockfd);

int main(int argc, char** argv){<br />
    int sockfd[];<br />
    struct sockaddr_in serveraddr;<br />
    int i;

    if (argc &lt; )<br />
        err_quit("Use: clisocket &lt;IPaddress&gt;");<br />
    for (i = ; i &lt;; ++i){

        sockfd[i] = Socket(AF_INET, SOCK_STREAM,);

        bzero(&amp;serveraddr, sizeof(struct sockaddr_in));<br />
        serveraddr.sin_family = AF_INET;<br />
        serveraddr.sin_port = htons(SERV_PORT);<br />
        Inet_pton(AF_INET, argv[], &amp;serveraddr.sin_addr);

        Connect(sockfd[i], (SA*)&amp;serveraddr, sizeof(serveraddr));

    }

    str_cli(stdin, sockfd[]);<br />
    exit();<br />
}

int str_cli1(FILE *fp, int sockfd){<br />
    char sendline[MAXLINE], recvline[MAXLINE];

    while(Fgets(sendline, MAXLINE, fp) != NULL){<br />
        Writen(sockfd, sendline, strlen(sendline));

        if (Readline(sockfd, recvline, MAXLINE) == )<br />
            err_quit("str_cli: server terminated prematurely");<br />
        Fputs(recvline, stdout);<br />
    }<br />
}</pre>
</div>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2knnxq.html">struts2中的OGNL详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mj3xr8.html">使用CocoaPods开发并打包静态库</a>
		</li>
						<li><a href="https://www.batexi.com/a/390lzej9.html">cookie和浏览器</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e7plz9.html">电脑不能浏览网页but能登录qq，解决方案总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mgvjjq.html">猜拳  GuessFist</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmx0m69.html">【译】velocity</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvpkoq.html">Ajax之旅（一）--什么是Ajax</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnmglq.html">C&plus;&plus;类的成员初始化列表的相关问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp07d69.html">RPC通信框架&mdash;&mdash;RCF介绍（替换COM）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dn32q.html">Android相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpe2yvq.html">事务的使用示例及WinForm实现中的若干问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjjyw38.html">&lbrack;Python&rsqb;新手写爬虫全过程（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zzxkn9.html">对Unity3d C&num;手动处理异常产生</a>
		</li>
						<li><a href="https://www.batexi.com/a/90meng38.html">SSH自动断开连接的原因、配置&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pyz1y8.html">iOS Regex匹配关键字并修改颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1m61xq.html">SpringBoot系列&mdash;&mdash;MyBatis整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rmw228.html">x变成y的最少操作次数（层次遍历）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1043w9.html">Quartz公共类，log4net 日志分目录 ，调度任务。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21z4o9.html">F查询和Q查询，事务及其他</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5p1yeq.html">rabbitmq使用方法&lpar;一&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xzw4r9.html">1&period;Basic Structure</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjrkwk9.html">velocity自定义动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnvorj8.html">HDOJ 3622 - Bomb Game 2-sat&plus;二分&period;&period;&period;&period;细心&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mrgweq.html">Collision使用 获取其组件执行变色操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2r2r8.html">android 解析json数据格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k172l39.html">Socket tips&colon; UDP Echo service - Server code</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z34g09.html">&lbrack;React&rsqb; React Router&colon; Route Parameters</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1v3oe9.html">POJ  2502  Subway（迪杰斯特拉）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm4w769.html">shell脚本加密</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde2xoz9.html">3、第3课CSS块级、行内元素、绝对定位、相对定位、固定位置20150922</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
